package com.perforce.workshop.tjuricek.p4java_ext;

import com.perforce.p4java.exception.P4JavaException;
import com.perforce.p4java.server.IOptionsServer;

import java.util.Map;

/**
 * Access to the "p4 revert" command
 */
public interface P4Revert extends P4ClientConnection, P4Errors {

    static P4Revert create(P4ClientConnection conn) {
        return new DefaultP4Revert(conn);
    }

    /**
     * Runs "p4 revert -c [changelist] //..."
     *
     * @param changelist Changelist ID
     */
    default void revertAll(String changelist) {
        try {
            String[] opts = new String[]{"-c", changelist, "//..."};

            IOptionsServer server = getOptionsServer();
            Map<String, Object>[] results = server.execMapCmd("revert", opts, null);

            checkError(results);

        } catch (P4JavaException p4) {
            throw new P4Exception(p4);
        }
    }
}
