package com.perforce.workshop.tjuricek.p4java_ext;

import com.perforce.p4java.exception.P4JavaException;
import com.perforce.p4java.server.IOptionsServer;

import java.util.Map;

/**
 * Basic interface to the "p4 sync" command
 */
public interface P4Sync extends P4ClientConnection, P4Errors {

    static P4Sync create(P4ClientConnection conn) {
        return new DefaultP4Sync(conn);
    }

    /**
     * Syncs all files in the indicated client workspace.
     * <p/>
     * Note that the underlying IOptionsServer will set the client before running, which you can
     * avoid doing if you pass in null; this may affect performance if you know the client is
     * already initialized correctly.
     */
    default void sync() {
        try {
            IOptionsServer server = getOptionsServer();

            Map<String, Object>[] results = server.execMapCmd("sync", new String[0], null);

            checkError(results);

        } catch (P4JavaException p4) {
            throw new P4Exception(p4);
        }
    }
}
